/* $Revision$ $Date$ $Author$ */
/***********************************************************************
*                                                                      *
* Licensed Materials - Property of IBM                                 *
* 5724-L01, 5655-N53, 5724-I82, 5655-R15                               *
* Copyright IBM Corporation 2008. All Rights Reserved.                 *
* US Government Users Restricted Rights- Use, duplication or disclosure*
* restricted by GSA ADP Schedule Contract with IBM Corp.               *
***********************************************************************/

/***********************************************************************
* Name:
*        jsCookie.js
*
* Function:
*        Provide a Cookie operation Object.
*
* Author:
*        xbyu(xbyu@cn.ibm.com)
*
* Status:
*        Version 1, Release 0
*
* Environment:
*
* Public Routines:
*
* Description:
*        ...
*
* Design Notes:
*        ...
*
* Change activity:
*
*  $Log$
*
***********************************************************************/ 
 
jsCookie = function()
{
    this.name = "";
    this.value = "";
    this.expires;
    this.domain = "";
    this.path = "";
    this.cOokie = document.cookie;
    var properties = ["name", "value", "expires", "domain", "path"];

    this.getCookie = function()
    {
        var name = this.name;
        if (name == null || typeof name == "undefined" || name =="")
            return this;
            
        var start = this.cOokie.indexOf(name + "=");
        if (start == -1)
            return this;
        start += name.length + 1;
        var end = this.cOokie.indexOf(';', start);
        if (end == -1)
            this.value = decodeURIComponent(this.cOokie.substring(start));
        else
            this.value = decodeURIComponent(this.cOokie.substring(start, end));
            
        return this;
    };
    
    this.write = function()
    {
        var cookiecontent = "";
        if (this.name != null && this.name != "" && this.value != null && this.value != "")
            cookiecontent += (this.name + "=" + encodeURIComponent(this.value));
        else
            return false;
              
        if (this.expires != null && this.expires != "" )
            cookiecontent += (";expires=" + this.expires.toGMTString());
        
        if (this.domain != null && this.domain != "" )
            cookiecontent += (";domain=" + encodeURIComponent(this.domain));
            
        if (this.path != null && this.path != "" )
            cookiecontent += (";path=" + encodeURIComponent(this.path));
 
        document.cookie = cookiecontent;
        return this;
    };
    
    this.cookieContent = function()
    {
        var cookiecontent = "";
        if (this.name != null && this.name != "" && this.value != null && this.value != "")
            cookiecontent += (this.name + "=" + encodeURIComponent(this.value));
        else
            return false;
            
        if (this.expires != null && this.expires != "" )
            cookiecontent += (";expires=" + this.expires.toGMTString());
        
        if (this.domain != null && this.domain != "" )
            cookiecontent += (";domain=" + encodeURIComponent(this.domain));
            
        if (this.path != null && this.path != "" )
            cookiecontent += (";path=" + encodeURIComponent(this.path));
            
        return cookiecontent;
    };
        
    this.setName = function( name)
    {
        this.name = name;
    };
    
    this.setPath = function( path)
    {
        this.path = path;
    };
    
    this.setDomain = function( domain)
    {
        this.domain = domain;
    };
    
    this.setValue = function( value)
    {
        this.value = value;
    };
    
    this.getValue = function()
    {
        return this.value;
    };
    
    this.setExpires = function( expireTime)
    {
        this.expires = new Date();
        this.expires.setTime(this.expires.getTime() + parseInt(expireTime));
    };
    
    this.getSubVal = function( name)
    {
        if (this.value != null && this.value != "")
        {
            var valuestring = this.value;
            
            var start = valuestring.indexOf(name + "=");
            if (start == -1)
                return "";
                
            start += name.length + 1;
            var end = valuestring.indexOf("&", start);
            if (end == -1)
                return valuestring.substring(start);
            
            return valuestring.substring(start, end);
        }
        return "";
    };
    
    this.deleteSubVal = function(cookieNodeID)
    {
    	if (this.value == null || this.value == "")
    		return false;
    		
    	var valuestring = this.value;
        var start = valuestring.indexOf(cookieNodeID + "=");
        if (start == -1)
            return false;
            
        var end = valuestring.indexOf("&", start);
        if (end == -1 && start == 0)
        	this.value = "";
        else if (end == -1)
        	this.value = valuestring.substring(0, start-1);
        else if (start == 0)
        	this.value = valuestring.substring(end+1);
        else
        	this.value = (valuestring.substring(0, start-1) + valuestring.substring(end));
        
        if (this.write()) return true;
        return false;
    };
    
    this.deleteSubValWithoutWritingCookie = function(cookieNodeID)
    {
    	if (this.value == null || this.value == "")
    		return false;
    		
    	var valuestring = this.value;
        var start = valuestring.indexOf(cookieNodeID + "=");
        if (start == -1)
            return false;
            
        var end = valuestring.indexOf("&", start);
        if (end == -1 && start == 0)
        	this.value = "";
        else if (end == -1)
        	this.value = valuestring.substring(0, start-1);
        else if (start == 0)
        	this.value = valuestring.substring(end+1);
        else
        	this.value = (valuestring.substring(0, start-1) + valuestring.substring(end));
        
        return true;
    };
    
    this.deleteCookie = function()
    {
        if (this.name != null && this.name != "")
        {
            var date=new Date();
            var ms= 1 * 1000;
            date.setTime(date.getTime() - ms);
            this.expires = date;
            this.write();
        }
    };
    
    this.toString = function()
    {
        return this.name + ";" + this.value + ";" + this.expires + ";" + this.domain + ";" + this.path;
    }
    
}
