import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from java.lang import System

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)
lineSeparator = System.getProperty("line.separator")

import printHelper as PrintHelper

def getMessageListenerType(raID):
	asMLTList = AdminTask.listMessageListenerTypes(raID)
	if(asMLTList == ""):
		return ''
	asMLTarr = asMLTList.split(lineSeparator)

	mlType = ''
	for asMLType in asMLTarr:
		if (asMLType == ''):
			break
		else:
			activationspeclist = AdminTask.listJ2CActivationSpecs(raID,"[-messageListenerType " + asMLType +" ]")
			activationspecarr = activationspeclist.split(lineSeparator)
			for activationspec in activationspecarr:
				if (activationspec == ''):
					break
				else:
					mlType = asMLType
	
	return mlType
#end def
					
def updateEmbededRAR(exportEarFile, appName, raDisplayName, raVersion, RAURI, raID):
	# Get the working temp dir
	migrationWorkDir = WPSMigrationUtil.getMigrationWorkDir()

	PrintHelper.printInfo("----Updating embedded adapter for app="+appName+" adapter="+raDisplayName+" ver="+raVersion)
	oldRAR = WPSMigrationUtil.getRARInsideEar(exportEarFile, migrationWorkDir)
	PrintHelper.printInfo("oldRAR="+oldRAR)
	updatedRAR = WPSMigrationUtil.getUpdatedAdapterRARLoc(oldRAR, raDisplayName, migrationWorkDir)
	PrintHelper.printInfo("----Generated new RAR file "+updatedRAR+ " for embedded adapter "+ raDisplayName + " for app="+appName)
	PrintHelper.printInfo("updatedRAR = " + updatedRAR)
	PrintHelper.printInfo("appName = " + appName)
	PrintHelper.printInfo("RAURI= " + RAURI)
	updateCmd = "[-operation update -contents "+ updatedRAR + " -contenturi "+ RAURI + "]"
	AdminApp.update(appName, "file", updateCmd)

	AdminConfig.save()
	#PrintHelper.printInfo("---------after updating the RAR---------------")

	# we will handle the message listenerType for Flat File adapter only
	if(raDisplayName.find('Flat Files') != -1 or raDisplayName.find('PeopleSoft') != -1):
		PrintHelper.printInfo("----Handling message listenerType for Flat Files adapter in app="+appName)
		try:

			asMLTList = AdminTask.listMessageListenerTypes(raID)
			asMLTarr = asMLTList.split(lineSeparator)
			for asMLType in asMLTarr:
				if (asMLType != ''):
					activationspeclist = AdminTask.listJ2CActivationSpecs(raID,"[-messageListenerType " + asMLType +" ]")
					activationspecarr = activationspeclist.split(lineSeparator)
					for activationspec in activationspecarr:
						if (activationspec != ''):
							profileFolder = System.getProperty('user.install.root')
							cell = AdminConfig.list("Cell")
							cellName = AdminConfig.showAttribute(cell,'name')
							fileName = profileFolder+fileSeparator+"config"+fileSeparator+"cells"+fileSeparator+cellName+fileSeparator+"applications"+fileSeparator+appName+".ear"+fileSeparator+"deployments"+fileSeparator+appName+fileSeparator+"deployment.xml"
							activationspecName = AdminConfig.showAttribute(activationspec,'name')
							WPSMigrationUtil.modifyMessgeListnertype(fileName,activationspecName)
		except:
			PrintHelper.printInfo("----Encounter error:")
			PrintHelper.printInfo(sys.exc_type)
			PrintHelper.printInfo(sys.exc_value)
	
	name = AdminConfig.showAttribute(raID,"name")
	#raname=name.split(".")[1]
	raname = WPSMigrationUtil.getPureAdapterName(raDisplayName)
	newadaptername = WPSMigrationUtil.getAdapterNewName(raDisplayName)
	
	if(raname != newadaptername):
		try:
			PrintHelper.printInfo("Adapter display name changed...")
			PrintHelper.printInfo("Old display name="+raname)
			PrintHelper.printInfo("New display name="+newadaptername)
			
			PrintHelper.printInfo("----Updating the adapter name. old name="+name)
			newName = name.replace(raname,newadaptername)
			AdminConfig.resetAttributes(raID,[["name",newName]])
			PrintHelper.printInfo("----Updated the adapter name. new name="+newName)
		except:
			PrintHelper.printInfo("----Failed to change the rar name from "+name+" to "+newName)
	#PrintHelper.printInfo("---update command="+updateCmd)
	AdminConfig.save()

	# Delete the Work Dir
	if ( WPSMigrationUtil.toRemoveTempFiles() ):
		WPSMigrationUtil.deleteFile(migrationWorkDir)
		#WPSMigrationUtil.deleteFile(tempDir1)

	PrintHelper.printInfo("----Successfully update the embeded adapter for app="+ appName +"!")
#end def updateEmbeddedRAR