import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from java.lang import System

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
# Define the script path
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper
import findStandaloneRAApplicationsForVersionConflict as FindStandAloneRAAppsForVersionConflict
import updateStandaloneRARForVersionConflict as UpdateStandAloneRARForVersionConflict
import migrateApp as MigrateApp

def getNodeType():
	nodeType = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.type")
	if (nodeType==""):
		nodelist = AdminConfig.list('Node')
		nodeArr = FindStandAloneRAAppsForVersionConflict.wsadminToList(nodelist)
		nodeNum = len(nodeArr)
		if ( nodeNum > 1 ):
			nodeType = "dmgr"
		else:
			nodeType = "node"
	
	return nodeType


WPSMigrationUtil.setWPSHome(wpsRootPath)
newRARFolder=wpsRootPath+fileSeparator+"installableApps"+fileSeparator
WPSMigrationUtil.setNewRARDir(newRARFolder)
tempFolder=WPSMigrationUtil.getSystemProperty("bpm.upgrade.backup.dir")
WPSMigrationUtil.setTempDir(tempFolder)

# Retrieve the value of WPS HOME from system environment property
#wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
nodeType = getNodeType()

if ( nodeType=="dmgr" ):
	PrintHelper.printInfo('Skip DMGR.')
else:
	#try:
	configurationFile = scriptsPath+"adapterMigrationInfo.xml"
	PrintHelper.printInfo("----Loading configuration info from "+configurationFile)
	WPSMigrationUtil.getAdapterMigrationInfo(configurationFile)
	#tempFolder = WPSMigrationUtil.getTempDir();

	nodeName = MigrateApp.getNodename();
	PrintHelper.printInfo('----Starting to find standalone RAR on node=')
	PrintHelper.printInfo(nodeName)
	raStandaloneRAAppList = FindStandAloneRAAppsForVersionConflict.findStandaloneRAApps(nodeName)
	#PrintHelper.printInfo('after find standalone RAR')
	for oneNode in raStandaloneRAAppList:
		toMigrateApps = []
		node = oneNode[0]
		PrintHelper.printInfo(node)
		adapters = oneNode[1]
		for oneAdapter in adapters:
			ra = oneAdapter[0]
			raN = oneAdapter[1]
			raV = oneAdapter[2]
			if ( WPSMigrationUtil.isSupportedAdapterName(raN)):
				UpdateStandAloneRARForVersionConflict.updateStandAloneRAR(nodeName, raN)
	#except:
	#	PrintHelper.printInfo('Failed with error')
	#	PrintHelper.printInfo( sys.exc_type)
	#	PrintHelper.printInfo( sys.exc_value)